Index: tags/rel-1.7.0/zoo-project/zoo-kernel/otbZooWatcher.cxx
===================================================================
--- branches/branch-1.7/zoo-project/zoo-kernel/otbZooWatcher.cxx	(revision 935)
+++ tags/rel-1.7.0/zoo-project/zoo-kernel/otbZooWatcher.cxx	(revision 942)
@@ -16,4 +16,5 @@
 =========================================================================*/
 #include "otbZooWatcher.h"
+#include "otbConfigure.h"
 #include "service_internal.h"
 
@@ -52,5 +53,7 @@
 ::StartFilter()
 {
+#if OTB_VERSION_MAJOR < 6 
   m_TimeProbe.Start();
+#endif
 }
 
@@ -59,4 +62,5 @@
 ::EndFilter()
 {
+#if OTB_VERSION_MAJOR < 6 
   m_TimeProbe.Stop();
   std::ostringstream elapsedTime;
@@ -68,3 +72,4 @@
             << " seconds)"
             << std::endl;
+#endif
 }
Index: tags/rel-1.7.0/zoo-project/zoo-kernel/request_parser.c
===================================================================
--- branches/branch-1.7/zoo-project/zoo-kernel/request_parser.c	(revision 935)
+++ tags/rel-1.7.0/zoo-project/zoo-kernel/request_parser.c	(revision 942)
@@ -1070,10 +1070,20 @@
 					       buffersize);
 				}
-			      else if (cur5 != NULL)/*
-				     && cur5->type == XML_CDATA_SECTION_NODE)*/{
-				xmlFree(mv);
-				if(cur5->content!=NULL){
-				  mv=xmlStrdup(cur5->content);
-				}
+			      else if (cur5 != NULL){
+				if(ltmp!= NULL && strstr(ltmp->value,"text/")!=NULL){
+				  xmlChar *tmp = xmlNodeListGetRawString (doc,
+									  cur4->xmlChildrenNode,
+									  0);
+				  addToMap (tmpmaps->content, "value",
+					    (char *) tmp);
+				  xmlFree (tmp);
+				}else{
+				  while(cur5!=NULL && cur5->type != XML_CDATA_SECTION_NODE)
+				    cur5=cur5->next;
+				  xmlFree(mv);
+				  if(cur5!=NULL && cur5->content!=NULL){
+				    mv=xmlStrdup(cur5->content);
+				  }
+			 	}
 			      }
 			    }
@@ -1859,5 +1869,5 @@
   if (r_inputs == NULL){
     if(mandatory>0){
-      char *replace=_("Mandatory parameter <%s> was not specified");
+      const char *replace=_("Mandatory parameter <%s> was not specified");
       char *message=(char*)malloc((strlen(replace)+strlen(toCheck)+1)*sizeof(char));
       sprintf(message,replace,toCheck);
@@ -1908,8 +1918,8 @@
     }
     if(hasValidValue<0){
-      char *replace=_("The value <%s> was not recognized, %s %s the only acceptable value.");
+      const char *replace=_("The value <%s> was not recognized, %s %s the only acceptable value.");
       nb=0;
       char *vvalues=NULL;
-      char* num=_("is");
+      const char* num=_("is");
       while(avalues[nb]!=NULL){
 	char *tvalues;
Index: tags/rel-1.7.0/zoo-project/zoo-kernel/service_internal_hpc.c
===================================================================
--- branches/branch-1.7/zoo-project/zoo-kernel/service_internal_hpc.c	(revision 935)
+++ tags/rel-1.7.0/zoo-project/zoo-kernel/service_internal_hpc.c	(revision 942)
@@ -69,5 +69,5 @@
 	  dupElements(cur)
 	};
-	char *geoLink="wcs_link";
+	const char *geoLink="wcs_link";
 	if(geo==2){
 	  geoLink="wfs_link";
@@ -213,5 +213,5 @@
       zooLock* lck;
       if((lck=lockFile(*conf,argv[1]->value,'r'))==NULL){
-	char* templateStr=_("Unable to lock the file for %s in read mode.");
+	const char* templateStr=_("Unable to lock the file for %s in read mode.");
 	char *tmpMessage=(char*)malloc((strlen(templateStr)+strlen(argv[0]->value)+1)*sizeof(char));
 	sprintf(tmpMessage,templateStr,argv[0]->value);
@@ -251,5 +251,5 @@
       if(unlockFile(*conf,zoo_file_locks[i])<1){
 	map* argv=getMapArray(queueMaps->content,"input",i);
-	char* templateStr=_("Unable to unlock the file for %s after execution.");
+	const char* templateStr=_("Unable to unlock the file for %s after execution.");
 	char *tmpMessage=(char*)malloc((strlen(templateStr)+strlen(argv->value)+1)*sizeof(char));
 	sprintf(tmpMessage,templateStr,argv->value);
Index: tags/rel-1.7.0/zoo-project/zoo-kernel/service_internal_python.c
===================================================================
--- branches/branch-1.7/zoo-project/zoo-kernel/service_internal_python.c	(revision 935)
+++ tags/rel-1.7.0/zoo-project/zoo-kernel/service_internal_python.c	(revision 942)
@@ -355,5 +355,5 @@
 #endif
     char *pStrErrorMessage = PyString_AsString(pvalue);
-  char *tmp0=_("Python module %s cannot be loaded. Message: %s\n");
+  const char *tmp0=_("Python module %s cannot be loaded. Message: %s\n");
   
   PyObject *trace=PyObject_Str(pvalue);
@@ -393,5 +393,5 @@
       if(pbt!=NULL)
 	free(pbt);
-      char* format=_("%s\nUnable to run your python process properly. Please check the following messages : %s");
+      const char* format=_("%s\nUnable to run your python process properly. Please check the following messages : %s");
       pbt=(char*)malloc((strlen(format)+strlen(tpbt)+strlen(PyString_AsString(trace))+1)*sizeof(char));
       sprintf(pbt,format,tpbt,PyString_AsString(trace));
@@ -400,5 +400,5 @@
       if(pbt!=NULL)
 	free(pbt);
-      char* format=_("%s \n Unable to run your python process properly. Unable to provide any further information.");
+      const char* format=_("%s \n Unable to run your python process properly. Unable to provide any further information.");
       pbt=(char*)malloc((strlen(format)+strlen(tpbt)+strlen(PyString_AsString(trace))+1)*sizeof(char));
       sprintf(pbt,format,tpbt);
Index: tags/rel-1.7.0/zoo-project/zoo-kernel/sshapi.c
===================================================================
--- branches/branch-1.7/zoo-project/zoo-kernel/sshapi.c	(revision 935)
+++ tags/rel-1.7.0/zoo-project/zoo-kernel/sshapi.c	(revision 942)
@@ -730,5 +730,5 @@
 	if((lck=lockFile(*conf,argv[1]->value,'w'))!=NULL){/**/
 	  if(ssh_copy(*conf,argv[1]->value,argv[2]->value,ssh_get_cnt(*conf))!=true){
-	    char* templateStr=_("Unable to copy over SSH the file requested for setting the value of %s.");
+	    const char* templateStr=_("Unable to copy over SSH the file requested for setting the value of %s.");
 	    char *tmpMessage=(char*)malloc((strlen(templateStr)+strlen(argv[0]->value)+1)*sizeof(char));
 	    sprintf(tmpMessage,templateStr,argv[0]->value);